//Matthew Sauve's firework ignitor Program
#include <SoftwareSerial.h>
//#include <WString.h>
//#include <string.h>
#include <EEPROM.h>
#include <MsTimer2.h>
//#include <ctype.h>

#define rxPin 4
#define txPin 14
#include "WProgram.h"
void setup();
void loop();
void check(int num);
void off();
void LCD();
SoftwareSerial mySerial =  SoftwareSerial(rxPin, txPin);

int fstate1 = 0;
int fstate2 = 0;
int fstate3 = 0;
int fstate4 = 0;
int fstate5 = 0;
int fstate6 = 0;
int fstate7 = 0;
int fstate8 = 0;
int v = 0;
int fire1 = 2;
int fire2 = 3;
int fire3 = 4;
int fire4 = 5;
int fire5 = 6;
int fire6 = 7;
int fire7 = 8;
int fire8 = 9;
int led = 13;
int button = 10;
int lbutton;
int t1f = 0;
int t2f = 0;
int t3f = 0;
int t4f = 0;
int t5f = 0;
int t6f = 0;
int t7f = 0;
int t8f = 0;
int d1 = 0;
int d2 = 0;
int d3 = 0;
int d4 = 0;
int d5 = 0;
int d6 = 0;
int d7 = 0;
int d8 = 0;
int load = 0;
boolean upload = true;
boolean ok = true;

void setup()
{
  Serial.begin(9600);
  MsTimer2::set(100, LCD); 
  MsTimer2::start();
  
     pinMode(txPin, OUTPUT);
   mySerial.begin(9600);      // 9600 baud is chip comm speed

   mySerial.print("?G216");   // set display geometry,  2 x 16 characters in this case
   delay(100);                // pause to allow LCD EEPROM to program
   
   mySerial.print("?BFF");    // set backlight to ff hex, maximum brightness
   delay(100);                // pause to allow LCD EEPROM to program
  
  t1f = EEPROM.read(1);
  t2f = EEPROM.read(2);
  t3f = EEPROM.read(3);
  t4f = EEPROM.read(4);
  t5f = EEPROM.read(5);
  t6f = EEPROM.read(6);
  t7f = EEPROM.read(7);
  t8f = EEPROM.read(8);
  d1 = EEPROM.read(9)*1000;
  d2 = EEPROM.read(10)*1000;
  d3 = EEPROM.read(11)*1000;
  d4 = EEPROM.read(12)*1000;
  d5 = EEPROM.read(13)*1000;
  d6 = EEPROM.read(14)*1000;
  d7 = EEPROM.read(15)*1000;
  d8 = EEPROM.read(16)*1000;
  
  pinMode(fire1,OUTPUT);
  pinMode(fire2,OUTPUT);
  pinMode(fire3,OUTPUT);
  pinMode(fire4,OUTPUT);
  pinMode(fire5,OUTPUT);
  pinMode(fire6,OUTPUT);
  pinMode(fire7,OUTPUT);
  pinMode(fire8,OUTPUT);
  pinMode(led, OUTPUT);
  pinMode(button, INPUT);
  digitalWrite(led, HIGH);
}

void loop()
{
    if(Serial.available()&&upload==true)
    {
    char ch = Serial.read();

    switch(ch) {
      case 's':
      ok = false;
      if(load == 0)
      mySerial.print("?f");
      load = 1;
      mySerial.print("?x03"); 
      mySerial.print("LOADING...");
      MsTimer2::stop();
      break;
      
      case '0'...'9':
      v = v * 10 + ch - '0';
      break;
      
      case 'a':
      t1f = v;
      v=0;
      break;
      
      case 'b':
      t2f = v;
      v=0;
      break;
      
      case 'c':
      t3f = v;
      v=0;
      break;
      
      case 'd':
      t4f = v;
      v=0;
      break;
      
      case 'e':
      t5f = v;
      v=0;
      break;
      
      case 'f':
      t6f = v;
      v=0;
      break;
      
      case 'g':
      t7f = v;
      v=0;
      break;
      
      case 'h':
      t8f = v;
      v=0;
      break;
      
      case 'l':
      d1 = v;
      v=0;
      break;
      
      case 'm':
      d2 = v;
      v=0;
      break;
      
      case 'n':
      d3 = v;
      v=0;
      break;
      
      case 'o':
      d4 = v;
      v=0;
      break;
      
      case 'p':
      d5 = v;
      v=0;
      break;
      
      case 'q':
      d6 = v;
      v=0;
      break;
      
      case 'r':
      d7 = v;
      v=0;
      break;
      
      case 't':
      d8 = v;
      v=0;
      break;
      
      case 'M':
      //Message();
      break;
      
      case 'z':
      for(int i = 0; i < 512; i++)
       EEPROM.write(i, 0);
      EEPROM.write(1,t1f);
      delay(62);
      EEPROM.write(2,t2f);
      delay(62);
      EEPROM.write(3,t3f);
      delay(62);
      EEPROM.write(4,t4f);
      delay(62);
      EEPROM.write(5,t5f);
      delay(62);
      EEPROM.write(6,t6f);
      delay(62);
      EEPROM.write(7,t7f);
      delay(62);
      EEPROM.write(8,t8f);
      delay(62);
      EEPROM.write(9, d1/1000);
      delay(62);
      EEPROM.write(10,d2/1000);
      delay(62);
      EEPROM.write(11,d3/1000);
      delay(62);
      EEPROM.write(12,d4/1000);
      delay(62);
      EEPROM.write(13,d5/1000);
      delay(62);
      EEPROM.write(14,d6/1000);
      delay(62);
      EEPROM.write(15,d7/1000);
      delay(62);
      EEPROM.write(16,d8/1000);
      ok = true;
      MsTimer2::start();
      break;
    }

    }
    if(ok==true&&upload==true)
    {
      if(digitalRead(button) == HIGH && lbutton == LOW)
     {
      upload  = false;
      mySerial.print("?f");
     }
     lbutton = digitalRead(button);
    }
    
    if(ok==true&&upload==false)
    {
     if(digitalRead(button) == HIGH && lbutton == LOW)
     {
      MsTimer2::stop();
      mySerial.print("?f");
      mySerial.print("?f?x06Fire!");
       
      Serial.print(t1f);
      Serial.print(" ");
      Serial.print(t2f);
      Serial.print(" ");
      Serial.print(t3f);
      Serial.print(" ");
      Serial.print(t4f);
      Serial.print(" ");
      Serial.print(t5f);
      Serial.print(" ");
      Serial.print(t6f);
      Serial.print(" ");
      Serial.print(t7f);
      Serial.print(" ");
      Serial.println(t8f);
      
      if(t1f>0)
        {
          delay(d1);
          
          if((t1f / 10000000) > 0)
           {
       check(t1f / 1000);
           }
          if((t1f / 1000000)-(t1f / 10000000*10) > 0)
           {
       check((t1f / 1000000)-(t1f / 10000000*10));
           }
          if((t1f / 100000)-(t1f / 1000000*10) > 0)
           {
       check((t1f / 1000010)-(t1f / 1000000*10));
           }
          if((t1f / 10000)-(t1f / 100000*10) > 0)
           {
       check((t1f / 10000)-(t1f / 100000*10));
           }
          if((t1f / 1000)-(t1f / 10000*10) > 0)
           {
       check((t1f / 1000)-(t1f / 10000*10));
           }
          if((t1f / 100)-(t1f / 1000*10) > 0)
           {
       check((t1f / 100)-(t1f / 1000*10));
           }
          if((t1f / 10)-(t1f / 100*10) > 0)
           {
       check((t1f / 10)-(t1f / 100*10));
           }
          if((t1f)-(t1f / 10*10) > 0)
           {
       check((t1f)-(t1f / 10*10));
           }
         }
        
      if(t2f>0)
        {
          delay(d2);
          off();
          
          if(t2f / 10000000 > 0)
           {
       check(t2f / 10000000);
           }
          if((t2f / 1000000)-(t2f / 10000000*10) > 0)
           {
       check((t2f / 1000000)-(t2f / 10000000*10));
           }
          if((t2f / 100000)-(t2f / 1000000*10) > 0)
           {
       check((t2f / 100000)-(t2f / 1000000*10));
           }
          if((t2f / 10000)-(t2f / 100000*10) > 0)
           {
       check((t2f / 10000)-(t2f / 100000*10));
           }
          if((t2f / 1000)-(t2f / 10000*10) > 0)
           {
       check((t2f / 1000)-(t2f / 10000*10));
           }
          if((t2f / 100)-(t2f / 1000*10) > 0)
           {
       check((t2f / 100)-(t2f / 1000*10));
           }
          if((t2f / 10)-(t2f / 100*10) > 0)
           {
       check((t2f / 10)-(t2f / 100*10));
           }
          if((t2f)-(t2f / 10*10) > 0)
           {
       check((t2f)-(t2f / 10*10));
           }
         }
        
      if(t3f>0)
        {
          delay(d3);
          off();
          
          if(t3f / 10000000 > 0)
           {
       check(t3f / 1000);
           }
          if((t3f / 1000000)-(t3f / 10000000*10) > 0)
           {
       check((t3f / 1000000)-(t3f / 10000000*10));
           }
          if((t3f / 100000)-(t3f / 1000000*10) > 0)
           {
       check((t3f / 100000)-(t3f / 1000000*10));
           }
          if((t3f / 10000)-(t3f / 100000*10) > 0)
           {
       check((t3f / 10000)-(t3f / 100000*10));
           }
          if((t3f / 1000)-(t3f / 10000*10) > 0)
           {
       check((t3f / 1000)-(t3f / 10000*10));
           }
          if((t3f / 100)-(t3f / 1000*10) > 0)
           {
       check((t3f / 100)-(t3f / 1000*10));
           }
          if((t3f / 10)-(t3f / 100*10) > 0)
           {
       check((t3f / 10)-(t3f / 100*10));
           }
          if((t3f)-(t3f / 10*10) > 0)
           {
       check((t3f)-(t3f / 10*10));
           }
         }
        
      if(t4f>0)
        {
          delay(d4);
          off();
          
          if(t4f / 10000000 > 0)
           {
       check(t4f / 10000000);
           }
          if((t4f / 1000000)-(t4f / 10000000*10) > 0)
           {
       check((t4f / 1000000)-(t4f / 10000000*10));
           }
          if((t4f / 100000)-(t4f / 1000000*10) > 0)
           {
       check((t4f / 100000)-(t4f / 1000000*10));
           }
          if((t4f / 10000)-(t4f / 100000*10) > 0)
           {
       check((t4f / 10000)-(t4f / 100000*10));
           }
          if((t4f / 1000)-(t4f / 10000*10) > 0)
           {
       check((t4f / 1000)-(t4f / 10000*10));
           }
          if((t4f / 100)-(t4f / 1000*10) > 0)
           {
       check((t4f / 100)-(t4f / 1000*10));
           }
          if((t4f / 10)-(t4f / 100*10) > 0)
           {
       check((t4f / 10)-(t4f / 100*10));
           }
          if((t4f)-(t4f / 10*10) > 0)
           {
       check((t4f)-(t4f / 10*10));
           }
         }
        
      if(t5f>0)
        {
          delay(d5);
          off();
          
          if(t5f / 10000000 > 0)
           {
       check(t5f / 10000000);
           }
          if((t5f / 1000000)-(t5f / 10000000*10) > 0)
           {
       check((t5f / 1000000)-(t5f / 10000000*10));
           }
          if((t5f / 100000)-(t5f / 1000000*10) > 0)
           {
       check((t5f / 100000)-(t5f / 1000000*10));
           }
          if((t5f / 10000)-(t5f / 100000*10) > 0)
           {
       check((t5f / 10000)-(t5f / 100000*10));
           }
          if((t5f / 1000)-(t5f / 10000*10) > 0)
           {
       check((t5f / 1000)-(t5f / 10000*10));
           }
          if((t5f / 100)-(t5f / 1000*10) > 0)
           {
       check((t5f / 100)-(t5f / 1000*10));
           }
          if((t5f / 10)-(t5f / 100*10) > 0)
           {
       check((t5f / 10)-(t5f / 100*10));
           }
          if((t5f)-(t5f / 10*10) > 0)
           {
       check((t5f)-(t5f / 10*10));
           }
         }
        
      if(t6f>0)
        {
          delay(d6);
          off();
          
          if(t6f / 10000000 > 0)
           {
       check(t6f / 10000000);
           }
          if((t6f / 1000000)-(t6f / 10000000*10) > 0)
           {
       check((t6f / 1000000)-(t6f / 10000000*10));
           }
          if((t6f / 100000)-(t6f / 1000000*10) > 0)
           {
       check((t6f / 100000)-(t6f / 1000000*10));
           }
          if((t6f / 10000)-(t6f / 100000*10) > 0)
           {
       check((t6f / 10000)-(t6f / 100000*10));
           }
          if((t6f / 1000)-(t6f / 10000*10) > 0)
           {
       check((t6f / 1000)-(t6f / 10000*10));
           }
          if((t6f / 100)-(t6f / 1000*10) > 0)
           {
       check((t6f / 100)-(t6f / 1000*10));
           }
          if((t6f / 10)-(t6f / 100*10) > 0)
           {
       check((t6f / 10)-(t6f / 100*10));
           }
          if((t6f)-(t6f / 10*10) > 0)
           {
       check((t6f)-(t6f / 10*10));
           }
         }
        
      if(t7f>0)
        {
          delay(d7);
          off();
          
          if(t7f / 10000000 > 0)
           {
       check(t7f / 10000000);
           }
          if((t7f / 1000000)-(t7f / 10000000*10) > 0)
           {
       check((t7f / 1000000)-(t7f / 10000000*10));
           }
          if((t7f / 100000)-(t7f / 1000000*10) > 0)
           {
       check((t7f / 100000)-(t7f / 1000000*10));
           }
          if((t7f / 10000)-(t7f / 100000*10) > 0)
           {
       check((t7f / 10000)-(t7f / 100000*10));
           }
          if((t7f / 1000)-(t7f / 10000*10) > 0)
           {
       check((t7f / 1000)-(t7f / 10000*10));
           }
          if((t7f / 100)-(t7f / 1000*10) > 0)
           {
       check((t7f / 100)-(t7f / 1000*10));
           }
          if((t7f / 10)-(t7f / 100*10) > 0)
           {
       check((t7f / 10)-(t7f / 100*10));
           }
          if((t7f)-(t7f / 10*10) > 0)
           {
       check((t7f)-(t7f / 10*10));
           }
         }
        
      if(t8f>0)
        {
          delay(d8);
          off();
          
          if(t8f / 10000000 > 0)
           {
       check(t8f / 10000000);
           }
          if((t8f / 1000000)-(t8f / 10000000*10) > 0)
           {
       check((t8f / 1000000)-(t8f / 10000000*10));
           }
          if((t8f / 100000)-(t8f / 1000000*10) > 0)
           {
       check((t8f / 100000)-(t8f / 1000000*10));
           }
          if((t8f / 10000)-(t8f / 100000*10) > 0)
           {
       check((t8f / 10000)-(t8f / 100000*10));
           }
          if((t8f / 1000)-(t8f / 10000*10) > 0)
           {
       check((t8f / 1000)-(t8f / 10000*10));
           }
          if((t8f / 100)-(t8f / 1000*10) > 0)
           {
       check((t8f / 100)-(t8f / 1000*10));
           }
          if((t8f / 10)-(t8f / 100*10) > 0)
           {
       check((t8f / 10)-(t8f / 100*10));
           }
          if((t8f)-(t8f / 10*10) > 0)
           {
       check((t8f)-(t8f / 10*10));
           }
        }
        delay(1000);
        off();
        MsTimer2::start();
     }
     lbutton = digitalRead(button);
    }
}

        void check(int num)
          { 
            if(num==1)
             digitalWrite(fire1,HIGH);
            if(num==2)
             digitalWrite(fire2,HIGH);
            if(num==3)
             digitalWrite(fire3,HIGH);
            if(num==4)
             digitalWrite(fire4,HIGH);
            if(num==5)
             digitalWrite(fire5,HIGH);
            if(num==6)
             digitalWrite(fire6,HIGH);
            if(num==7)
             digitalWrite(fire7,HIGH);
            if(num==8)
             digitalWrite(fire8,HIGH);
          }

        void off()
          {
            digitalWrite(fire1, LOW);
            digitalWrite(fire2, LOW);
            digitalWrite(fire3, LOW);
            digitalWrite(fire4, LOW);
            digitalWrite(fire5, LOW);
            digitalWrite(fire6, LOW);
            digitalWrite(fire7, LOW);
            digitalWrite(fire8, LOW);
          }

        void LCD()
          {
            if(upload==true)
            {
             if(load == 1)
             mySerial.print("?f");
             load = 0;
            mySerial.print("?x03?y0Upload or?x02?y1Push To Arm");
            //mySerial.print("");
            //delay(50);
            //mySerial.print("");
            //mySerial.print("");
            }
            else
            {
            mySerial.print("?x02");
            mySerial.print("Push To Fire");
            }
          }

    /*    void Message()
          {
              if(Serial.available())
    {
    char ch = Serial.read();

    switch(ch) {
      case 'a':
      message = strcat(message, 'a');
      break;
      
      case 'b':
      message = strcat(message, b);
      break;
      
      case 'c':
      message = strcat(message, c);
      break;
      
      case 'd':
      message = strcat(message, d);
      break;
      
      case 'e':
      message = strcat(message, e);
      break;
      
      case 'f':
      message = strcat(message, f);
      break;
      
      case 'g':
      message = strcat(message, g);
      break;
      
      case 'h':
      message = strcat(message, h);
      break;
      
      case 'i':
      message = strcat(message, i);
      break;
      
      case 'j':
      message = strcat(message, j);
      break;
      
      case 'k':
      message = strcat(message, k);
      break;
      
      case 'l':
      message = strcat(message, l);
      break;
      
      case 'm':
      message = strcat(message, m);
      break;
     
      case 'n':
      message = strcat(message, n);
      break;
      
      case 'o':
      message = strcat(message, o);
      break;
      
      case 'p':
      message = strcat(message, p);
      break;
      
      case 'q':
      message = strcat(message, q);
      break;
      
      case 'r':
      message = strcat(message, r);
      break;
      
      case 's':
      message = strcat(message, s);
      break;
      
      case 't':
      message = strcat(message, t);
      break;
      
      case 'u':
      message = strcat(message, u);
      break;
      
      case 'v':
      message = strcat(message, v);
      break;
      
      case 'w':
      message = strcat(message, w);
      break;
      
      case 'x':
      message = strcat(message, x);
      break;
      
      case 'y':
      message = strcat(message, y);
      break;
      
      case 'z':
      message = strcat(message, z);
      break;    
    
      case 'A':
      message = strcat(message, A);
      break;
      
      case 'B':
      message = strcat(message, B);
      break;
      
      case 'C':
      message = strcat(message, C);
      break;
      
      case 'D':
      message = strcat(message, D);
      break;
      
      case 'E':
      message = strcat(message, E);
      break;
      
      case 'F':
      message = strcat(message, F);
      break;
      
      case 'G':
      message = strcat(message, G);
      break;
      
      case 'H':
      message = strcat(message, H);
      break;
      
      case 'I':
      message = strcat(message, I);
      break;
      
      case 'J':
      message = strcat(message, J);
      break;
      
      case 'K':
      message = strcat(message, K);
      break;
      
      case 'L':
      message = strcat(message, L);
      break;
      
      case 'M':
      message = strcat(message, M);
      break;
     
      case 'N':
      message = strcat(message, N);
      break;
      
      case 'O':
      message = strcat(message, O);
      break;
      
      case 'P':
      message = strcat(message, P);
      break;
      
      case 'Q':
      message = strcat(message, Q);
      break;
      
      case 'R':
      message = strcat(message, R);
      break;
      
      case 'S':
      message = strcat(message, S);
      break;
      
      case 'T':
      message = strcat(message, T);
      break;
      
      case 'U':
      message = strcat(message, U);
      break;
      
      case 'V':
      message = strcat(message, V);
      break;
      
      case 'W':
      message = strcat(message, W);
      break;
      
      case 'X':
      message = strcat(message, X);
      break;
      
      case 'Y':
      message = strcat(message, Y);
      break;
      
      case 'Z':
      message = strcat(message, Z);
      break; 
    
      case '!':
      message = strcat(message, exclam);
      break;
    }
          }
          }
          
          void strcat(char* original, char appended)
{
    while (*original++)
	  ;
    *original++ = appended;
    if (appended)
	  *original = '\0';
} */


int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

